Index
$#! · 0-9 · A · B · C · D · E · F · G · H · I · J · K · L · M · N · O · P · Q · R · S · T · U · V · W · X · Y · Z

$#! |
| +UVM_CONFIG_DB_TRACE
| +UVM_DUMP_CMDLINE_ARGS
| +UVM_OBJECTION_TRACE
| +UVM_PHASE_TRACE
| +UVM_RESOURCE_DB_TRACE
| +uvm_set_config_bitstream
| `UVM_COMPONENT_CONFIG_MODE_DEFAULT
| `uvm_report_begin
| `uvm_report_end
0-9 |
| 2-2020 Class Reference UVM 1800
A |
| Active Phase Objection uvm_phase_hopper
| apply_config_settings uvm_component
| apply_config_settings_mode uvm_component
| atomic_lock uvm_reg_sequence
| atomic_unlock uvm_reg_sequence
| Audit Trail uvm_resource_base
B |
| begin_tr uvm_component
C |
| cbs_type uvm_event#(T)
| cleanup_phase uvm_phase_hopper
| clear uvm_process_guard_base
| Command line configuration
| Command Line Debug
| compose_report_message uvm_default_report_server
| CONFIG_DEFAULT uvm_component
| config_mode_e uvm_component
| config_mode_t uvm_component
| Core Service
| create_backdoor_probe uvm_polling_backdoor
| create_probe uvm_hdl_polling
D |
| debug_connected_to uvm_port_base
| debug_create_by_name uvm_default_factory
| debug_create_by_type uvm_default_factory
| debug_provided_to uvm_port_base
| debug_report_catcher uvm_report_catcher
| do_check_error uvm_reg_err_service
| do_close uvm_text_tr_stream
| do_close_db uvm_text_tr_database
| do_compare uvm_tlm_generic_payload
| do_copy uvm_reg_item
| do_establish_link uvm_text_tr_database
| do_free uvm_text_tr_stream
| do_on_hdl_change uvm_hdl_polling_cbs
| do_on_path_change uvm_hdl_polling_cbs
| do_open uvm_text_tr_stream
| do_open_db uvm_text_tr_database
| do_open_recorder uvm_text_tr_stream
| do_open_stream uvm_text_tr_database
| do_read uvm_resource#(T)
| do_trigger uvm_process_guard#(T)uvm_process_guard_base
| do_write uvm_resource#(T)
| drop_objection uvm_phase_hopper
E |
| enable_report_id_count_summary uvm_default_report_server
| end_phase uvm_phase_hopper
| evict uvm_cache(KEY_T,DATA_T)uvm_lru_cache(KEY_T,DATA_T)
| evict_to_max uvm_cache(KEY_T,DATA_T)uvm_lru_cache(KEY_T,DATA_T)
| execute_on uvm_phase_hopper
| execute_phase uvm_phase_hopper
| exists uvm_cache(KEY_T,DATA_T)uvm_config_db_default_implementation_t#(T)uvm_config_db_implementation_t#(T)uvm_lru_cache(KEY_T,DATA_T)
| extension uvm_reg_item
F |
| Factory Component and Object Wrappers
| find_unused_resources uvm_resource_pool
| finish_phase uvm_phase_hopper
| flush uvm_cache(KEY_T,DATA_T)uvm_reg_predictor
G |
| get uvm_cache(KEY_T,DATA_T)uvm_config_db_default_implementation_t#(T)uvm_config_db_implementation_t#(T)uvm_lru_cache(KEY_T,DATA_T)uvm_phase_hopper
| get_backdoor uvm_hdl_polling
| get_by_name uvm_resource_db_default_implementation_t#(T)uvm_resource_db_implementation_t#(T)
| get_by_type uvm_resource_db_default_implementation_t#(T)uvm_resource_db_implementation_t#(T)
| get_comp uvm_port_base
| get_connected_to uvm_port_component#(PORT)uvm_port_component_base
| get_context uvm_process_guard#(T)
| get_default_map uvm_reg
| get_default_printer uvm_default_coreservice_t
| get_enable_print_topology uvm_root
| get_first_copy uvm_copier
| get_global_hopper uvm_phase_hopper
| get_hdl_poll_cb_registered uvm_hdl_polling
| get_imp uvm_config_db_implementation_t#(T)uvm_resource_db_implementation_t#(T)
| get_last_copy uvm_copier
| get_max_size uvm_cache(KEY_T,DATA_T)
| get_next_copy uvm_copier
| get_num_copies uvm_copier
| get_number_callbacks uvm_hdl_polling
| get_objection uvm_phase_hopper
| get_objection_count uvm_phase_hopper
| get_objection_total uvm_phase_hopper
| get_phase_hopper uvm_coreservice_t
| get_prev_copy uvm_copier
| get_print_config_matches uvm_component
| get_process uvm_process_guard_base
| get_rand_mode uvm_reg_field
| get_signal_size uvm_polling_backdoor
| get_value_change_count uvm_hdl_polling
| Global Macros
| Globals
H |
| HDL Signal Polling
| hdl_read uvm_polling_backdoor
| Hook uvm_process_guard_base
I |
| Implementation Agnostic API uvm_text_tr_database uvm_text_tr_stream
| Implementation Specific API uvm_text_recorder uvm_text_tr_database
| is_terminated uvm_process_guard_base
| is_tracing uvm_config_db_options uvm_resource_db_options
K |
| keys uvm_cache(KEY_T,DATA_T)uvm_lru_cache(KEY_T,DATA_T)
| kind uvm_reg_item
M |
| Macros Global macros/ uvm_global_defines.svh macros/ uvm_message_defines.svh uvm_sequencer_base
| Message Macros
| Methods Global uvm_abstract_component_registry#(T,Tname)uvm_abstract_object_registry#(T,Tname)uvm_cache(KEY_T,DATA_T)uvm_component uvm_component_registry#(T,Tname)uvm_config_db_default_implementation_t#(T)uvm_config_db_implementation_t#(T)uvm_config_db_options uvm_copier uvm_coreservice_t uvm_default_coreservice_t uvm_default_factory uvm_default_report_server uvm_hdl_polling uvm_hdl_polling_cbs uvm_lru_cache(KEY_T,DATA_T)uvm_object_registry#(T,Tname)uvm_packer uvm_polling_backdoor uvm_port_base uvm_port_component#(PORT)uvm_port_component_base uvm_process_guard#(T)uvm_reg uvm_reg_err_service uvm_reg_field uvm_reg_item uvm_reg_predictor uvm_reg_sequence uvm_report_catcher uvm_resource#(T)uvm_resource_db uvm_resource_db_default_implementation_t#(T)uvm_resource_db_implementation_t#(T)uvm_resource_db_options uvm_resource_debug uvm_resource_pool uvm_root uvm_tlm_generic_payload
| Miscellaneous
N |
| new uvm_cache(KEY_T,DATA_T)uvm_hdl_polling uvm_hdl_polling_cbs uvm_lru_cache(KEY_T,DATA_T)uvm_phase_hopper uvm_polling_backdoor uvm_process_guard#(T)uvm_process_guard_base uvm_text_tr_database uvm_text_tr_stream
O |
| offset uvm_reg_item
| optional_data uvm_cache(KEY_T,DATA_T)
| optional_keys uvm_cache(KEY_T,DATA_T)
P |
| pack_object_with_meta uvm_packer
| Packing Macros
| parent uvm_reg_item
| peek uvm_phase_hopper
| Phase Component Traversal uvm_phase_hopper
| Phase Graph Execution uvm_phase_hopper
| poll_bkdr_wait_for_hdl_change uvm_polling_backdoor
| polling_wait_for_value uvm_hdl_polling
| Port Base Classes
| print_accessors uvm_resource_base uvm_resource_debug
| print_catcher uvm_report_catcher
| print_config uvm_component
| Process Guard Status uvm_process_guard_base
| Process Guards
| process_phase uvm_phase_hopper
| put uvm_cache(KEY_T,DATA_T)uvm_lru_cache(KEY_T,DATA_T)
Q |
| Queue API uvm_phase_hopper
R |
| raise_objection uvm_phase_hopper
| read uvm_resource#(T)
| read_by_name uvm_resource_db_default_implementation_t#(T)uvm_resource_db_implementation_t#(T)
| read_by_type uvm_resource_db_default_implementation_t#(T)uvm_resource_db_implementation_t#(T)
| record_all_messages uvm_default_report_server
| record_read_access uvm_resource_base uvm_resource_debug
| record_write_access uvm_resource_base uvm_resource_debug
| Recording Macros
| register_hdl_path uvm_hdl_polling
| Report Catcher
| Resource Base Classes
| Resources
| run_phases uvm_phase_hopper
S |
| schedule_phase uvm_phase_hopper
| set uvm_config_db_default_implementation_t#(T)uvm_config_db_implementation_t#(T)uvm_resource_db_default_implementation_t#(T)uvm_resource_db_implementation_t#(T)
| set_anonymous uvm_resource_db_default_implementation_t#(T)uvm_resource_db_implementation_t#(T)
| set_backdoor uvm_hdl_polling
| set_default uvm_resource_db_default_implementation_t#(T)uvm_resource_db_implementation_t#(T)
| set_enable_print_topology uvm_root
| set_file_name uvm_text_tr_database
| set_hdl_path uvm_hdl_polling uvm_polling_backdoor
| set_hdl_poll_cb_registered uvm_hdl_polling
| set_imp uvm_config_db_implementation_t#(T)uvm_resource_db_implementation_t#(T)
| set_max_size uvm_cache(KEY_T,DATA_T)
| set_override uvm_resource_db uvm_resource_db_default_implementation_t#(T)uvm_resource_db_implementation_t#(T)
| set_override_name uvm_resource_db uvm_resource_db_default_implementation_t#(T)uvm_resource_db_implementation_t#(T)
| set_override_type uvm_resource_db uvm_resource_db_default_implementation_t#(T)uvm_resource_db_implementation_t#(T)
| set_poll
| set_print_config_matches uvm_component
| set_rand_mode uvm_reg_field
| set_recording_enabled uvm_component
| set_type_alias uvm_abstract_component_registry#(T,Tname)uvm_abstract_object_registry#(T,Tname)uvm_component_registry#(T,Tname)uvm_object_registry#(T,Tname)
| show_msg uvm_config_db_default_implementation_t#(T)uvm_config_db_implementation_t#(T)uvm_resource_db_default_implementation_t#(T)uvm_resource_db_implementation_t#(T)
| show_terminator uvm_default_report_server
| show_verbosity uvm_default_report_server
| Singleton Accessors uvm_phase_hopper
| size uvm_cache(KEY_T,DATA_T)uvm_lru_cache(KEY_T,DATA_T)
| size_t uvm_cache(KEY_T,DATA_T)
| start uvm_reg_sequence
| start_phase uvm_phase_hopper
T |
| this_type uvm_cache(KEY_T,DATA_T)uvm_process_guard#(T)
| Transitions uvm_phase_hopper
| traverse_on uvm_phase_hopper
| trigger_modified uvm_config_db_default_implementation_t#(T)uvm_config_db_implementation_t#(T)
| try_get uvm_phase_hopper
| try_peek uvm_phase_hopper
| try_put uvm_phase_hopper
| turn_off_tracing uvm_config_db_options uvm_resource_db_options
| turn_on_tracing uvm_config_db_options uvm_resource_db_options
| Types uvm_cache(KEY_T,DATA_T)uvm_component uvm_event#(T)uvm_process_guard#(T)
U |
| unpack_object_with_meta uvm_packer
| uvm_abstract_component_registry#(T,Tname)
| uvm_abstract_object_registry#(T,Tname)
| uvm_cache(KEY_T,DATA_T)
| uvm_component
| uvm_component_registry#(T,Tname)
| uvm_config_db_default_implementation_t#(T)
| uvm_config_db_implementation_t#(T)
| uvm_config_db_options
| uvm_copier
| uvm_core_state
| uvm_coreservice_t
| uvm_default_coreservice_t
| uvm_default_factory
| uvm_default_report_server
| UVM_DISABLE_AUTO_ITEM_RECORDING uvm_sequencer_base
| uvm_event#(T)
| uvm_get_poll
| uvm_hdl_polling
| uvm_hdl_polling_cbs
| uvm_init
| uvm_line_printer
| uvm_lru_cache(KEY_T,DATA_T)
| uvm_object_registry#(T,Tname)
| uvm_packer
| uvm_phase_hopper
| uvm_polling_backdoor
| uvm_port_base
| uvm_port_component#(PORT)
| uvm_port_component_base
| uvm_port_list
| uvm_printer
| uvm_process_guard#(T)
| uvm_process_guard_base
| uvm_reg
| uvm_reg_err_service
| uvm_reg_field
| uvm_reg_item
| uvm_reg_predictor
| uvm_reg_sequence
| uvm_report_catcher
| uvm_resource#(T)
| uvm_resource_base
| uvm_resource_db
| uvm_resource_db_default_implementation_t#(T)
| uvm_resource_db_implementation_t#(T)
| uvm_resource_db_options
| uvm_resource_debug
| uvm_resource_pool
| uvm_root
| uvm_sequencer_base
| uvm_table_printer
| uvm_text_recorder
| uvm_text_tr_database
| uvm_text_tr_stream
| uvm_tlm_generic_payload
| uvm_tree_printer
| uvm_wait_for_nba_region
V |
| value uvm_reg_item
| Variables Global uvm_component uvm_default_report_server uvm_reg_item uvm_sequencer_base
W |
| wait_for_hdl_change uvm_hdl_polling
| wait_for_objection uvm_phase_hopper
| wait_for_sequences_count uvm_sequencer_base
| wait_for_waiters uvm_phase_hopper
| wait_modified uvm_config_db_default_implementation_t#(T)uvm_config_db_implementation_t#(T)
| write uvm_resource#(T)
| write_attribute uvm_text_recorder
| write_attribute_int uvm_text_recorder
| write_by_name uvm_resource_db_default_implementation_t#(T)uvm_resource_db_implementation_t#(T)
| write_by_type uvm_resource_db_default_implementation_t#(T)uvm_resource_db_implementation_t#(T)

+UVM_CONFIG_DB_TRACE turns on tracing of configuration DB accesses.
+UVM_DUMP_CMDLINE_ARGS allows the user to dump all command line arguments to the reporting mechanism.
+UVM_OBJECTION_TRACE turns on tracing of objection activity.
+UVM_PHASE_TRACE turns on tracing of phase executions.
+UVM_RESOURCE_DB_TRACE turns on tracing of resource DB accesses.
+uvm_set_config_bitstream=<comp>,<field>,<value> works like its procedural counterpart uvm_config_db#(uvm_bitstream_t)::set().
Defines the default configuration mode used by uvm_component::apply_config_settings_mode.
Opens a code block which will only execute if action is not UVM_NO_ACTION and VERBOSITY is lower than the configured verbosity on the report object RO for the associated SEVERITY and ID pair.
Ends a block opened using `uvm_report_begin.
This library implements the API as documented in the IEEE 1800.2-2020 standard.
The apply_config_settings method diverges from the 1800.2 standard definition, using apply_config_settings_mode to determine how the resource pool shall be queried.

> virtual function config_mode_t apply_config_settings_mode()

Controls the configuration mode for uvm_component::apply_config_settings.

> virtual task atomic_lock()

Establishes an exclusive atomic lock for the current process.

> virtual function void atomic_unlock()

Releases the lock acquired via atomic_lock.
To find out what is happening as the simulation proceeds, an audit trail of each read and write is kept.
Implementation of uvm_component::begin_tr as described in IEEE 1800.2-2020.
Callback typedef for this event type.

> protected virtual task cleanup_phase(
> | uvm_phase | phase
> )

Performs actions associated with transitioning phase state to the UVM_PHASE_CLEANUP or UVM_PHASE_JUMPING state.

> function process clear()

Clears the currently guarded process if it has not yet terminated.
The following argument is provided in addition to those required by IEEE UVM 1800.2-2020.
Debug command line plusargs that are available in the Accellera reference implementation but not documented in the IEEE UVM 1800.2-2020 LRM

> virtual function string compose_report_message(
> | uvm_report_message | report_message, |  |
> | string | report_object_name | = | ""
> )

Constructs the actual string sent to the file or command line from the report message.

> localparam config_mode_t CONFIG_DEFAULT = `UVM_COMPONENT_CONFIG_MODE_DEFAULT

Default configuration mode used by apply_config_settings_mode.
Enumeration for controlling component config settings.
Value type for storing config_mode_e values

> virtual function bit create_backdoor_probe(
> | int | key, |  |
> | string | fullname, |  |
> | bit | enable | = | 1
> )

This function registers a backdoor probe on the signal.

> function bit create_probe(
> | uvm_hdl_polling | p, |  |
> | string | fullname, |  |
> | bit | enable | = | 1
> )

This method creates a probe.

> function void debug_connected_to (
> | int | level | = | 0,
> | int | max_level | = | -1
> )

The debug_connected_to method outputs a visual text display of the port/export/imp network to which this port connects (i.e., the port’s fanout).

> virtual function void debug_create_by_name (
> | string | requested_type_name, |  |
> | string | parent_inst_path | = | "",
> | string | name | = | ""
> )

Debug traces for create_*_by_name methods.

> virtual function void debug_create_by_type (
> | uvm_object_wrapper | requested_type, |  |
> | string | parent_inst_path | = | "",
> | string | name | = | ""
> )

Debug traces for create_*_by_type methods.

> function void debug_provided_to (
> | int | level | = | 0,
> | int | max_level | = | -1
> )

The debug_provided_to method outputs a visual display of the port/export network that ultimately connect to this port (i.e., the port’s fanin).

> static function void debug_report_catcher(
> | int | what | = | 0
> )

Turn on report catching debug information.

> virtual function void do_check_error(
> | uvm_reg | this_reg,
> | uvm_reg_data_t | expected,
> | uvm_reg_data_t | actual,
> | uvm_reg_map | map,
> | uvm_reg_data_t | valid_bits_mask
> )

Called when do_check finds a mismatch to create the error message and any other supporting information.

> protected virtual function void do_close()

Callback triggered via uvm_tr_stream::close.

> protected virtual function bit do_close_db()

Close the backend connection to the database.

> function bit do_compare(
> | uvm_object | rhs,
> | uvm_comparer | comparer
> )

Compares this generic payload to rhs.

> virtual function void do_copy(
> | uvm_object | rhs
> )

Copy the rhs object into this object.

> protected virtual function void do_establish_link(
> | uvm_link_base | link
> )

Establishes a link between two elements in the database

> protected virtual function void do_free()

Callback triggered via uvm_tr_stream::free.
To be implemented by extended classes to perform an action upon a value change of a register or a field
To be implemented by extended classes to perform an action upon a value change of a path hdl_path is the path that its value has changed val is the actual value of the path after it was changed size is the size in bits of the path’s value

> protected virtual function void do_open(
> | uvm_tr_database | db,
> | string | scope,
> | string | stream_type_name
> )

Callback triggered via uvm_tr_database::open_stream.

> protected virtual function bit do_open_db()

Open the backend connection to the database.

> protected virtual function uvm_recorder do_open_recorder(
> | string | name,
> | time | open_time,
> | string | type_name
> )

Marks the beginning of a new record in the stream

> protected virtual function uvm_tr_stream do_open_stream(
> | string | name,
> | string | scope,
> | string | type_name
> )

Provides a reference to a stream within the database.

> virtual function void do_trigger()

Hook called when the guarded process transitions to either the `FINISHED` or `KILLED` state.

> pure virtual function void do_trigger()

Hook called when the guarded process transitions to either the `FINISHED` or `KILLED` state.

> protected virtual function void drop_objection(
> | uvm_object | obj, |  |
> | string | description | = | "",
> | int | count | = | 1
> )

This is a pass through to uvm_objection::drop_objection on the objection returned by get_objection.

> bit enable_report_id_count_summary=1

A flag to enable report count summary for each ID

> protected virtual task end_phase(
> | uvm_phase | phase
> )

Performs actions associated with transitioning phase state to the UVM_PHASE_ENDED state.

> pure virtual function optional_data evict(
> | KEY_T | key
> )

Removes the data at key from the cache.

> virtual function optional_data evict(
> | KEY_T | key
> )

Removes the data at key from the cache.

> pure virtual protected function void evict_to_max()

Hook for evicting all keys greater than maximum size.

> protected virtual function void evict_to_max()

Implementation of uvm_cache#(KEY_T,DATA_T)::evict_to_max hook.

> virtual function void execute_on(
> | uvm_phase | imp,
> | uvm_component | comp,
> | uvm_phase | node
> )

Calls execute on imp, passing in comp, and node.

> protected virtual task execute_phase(
> | uvm_phase | phase
> )

Performs actions associated with transitioning phase state to the UVM_PHASE_EXECUTING state.

> pure virtual function bit exists(
> | KEY_T | key
> )

Returns true if key exists in the cache, otherwise returns false.

> virtual function bit exists(
> | uvm_component | cntxt,
> | string | inst_name,
> | string | field_name,
> | bit | rpterr
> )

Provides an implementation of get @uvm-accellera

> pure virtual function bit exists(
> | uvm_component | cntxt,
> | string | inst_name,
> | string | field_name,
> | bit | rpterr
> )

Intended to provide the functionality for uvm_config_db#(T)::exists @uvm-contrib

> virtual function bit exists(
> | KEY_T | key
> )

Returns true if key exists in the cache, otherwise returns false.

> rand uvm_object extension

Handle to optional user data, as conveyed in the call to write(), read(), mirror(), or update() used to trigger the operation.
This section defines the proxy component and object classes used by the factory.

> function uvm_resource_types::rsrc_q_t find_unused_resources()

Locate all the resources that have at least one write and no reads

> protected virtual task finish_phase(
> | uvm_phase | phase
> )

Performs actions associated with transitioning phase state to the UVM_PHASE_DONE state.

> virtual function void flush()

Evicts all keys from the cache.

> virtual function void flush()

Clear the state of the predictor including the pending writes.

> pure virtual function optional_data get(
> | KEY_T | key
> )

Returns data associated with key.

> virtual function bit get (
> |  | uvm_component | cntxt,
> |  | string | inst_name,
> |  | string | field_name,
> | inout | T | value
> )

Provides an implementation of get, including support for config_db tracing @uvm-accellera

> pure virtual function bit get (
> |  | uvm_component | cntxt,
> |  | string | inst_name,
> |  | string | field_name,
> | inout | T | value
> )

Intended to provide the functionality for uvm_config_db#(T)::get @uvm-contrib

> virtual function optional_data get(
> | KEY_T | key
> )

Returns data associated with key.

> protected virtual task get(
> | output | uvm_phase | phase
> )

Retrieves the next phase from the hopper.

> function uvm_polling_backdoor get_backdoor()

simple setter and getter functions for the backdoor mechanism @uvm-accellera The details of this API are specific to the Accellera implementation

> virtual function rsrc_t get_by_name(
> | string | scope,
> | string | name,
> | bit | rpterr
> )

Provides an implementation of get_by_name, with a warning if the matching resource is the wrong type.

> pure virtual function rsrc_t get_by_name(
> | string | scope,
> | string | name,
> | bit | rpterr
> )

Intended to provide the functionality for uvm_resource_db#(T)::get_by_name @uvm-contrib

> virtual function rsrc_t get_by_type(
> | string | scope
> )

Provides an implementation of get_by_type, with a warning if the resource was not located.

> pure virtual function rsrc_t get_by_type(
> | string | scope
> )

Intended to provide the functionality for uvm_resource_db#(T)::get_by_type @uvm-contrib

> virtual function uvm_port_component_base get_comp()

Returns a handle to the internal proxy component representing this port.

> virtual function void get_connected_to(
> | ref | uvm_port_list | list
> )

Implementation of the pure function declared in uvm_port_component_base

> pure virtual function void get_connected_to(
> | ref | uvm_port_list | list
> )

For a port or export type, this function fills list with all of the ports, exports and implementations that this port is connected to.

> function T get_context()

Returns the context with which the process guard was initialized.

> virtual function uvm_reg_map get_default_map ()

> virtual function uvm_printer get_default_printer()

Implementation of the get_default_printer method, as defined in section F.4.1.4.13 of 1800.2-2020.

> function bit get_enable_print_topology ()

Gets the variable to enable printing the entire testbench topology just after completion of the end_of_elaboration phase..

> static function uvm_phase_hopper get_global_hopper()

Returns the global phase hopper.

> function bit get_hdl_poll_cb_registered

Accessor method to determine if a callback was registered for this object.

> static function uvm_config_db_implementation_t #(
> | T
> ) get_imp()

Returns the implementation instance to be used.

> static function uvm_resource_db_implementation_t #(
> | T
> ) get_imp ()

Returns the implementation instance to be used.

> virtual function size_t get_max_size()

Returns the current maximum size of the cache.

> function int unsigned get_num_copies(
> | uvm_object | rhs
> )

Returns the number of times the rhs has been copied to a unique lhs
This method returns the number of callback paths registered.

> protected virtual function uvm_objection get_objection()

Retrieves the Active Phase Objection.

> virtual function int get_objection_count(
> | uvm_object | obj | = | null
> )

This is a pass through to uvm_objection::get_objection_count on the objection returned by get_objection.

> virtual function int get_objection_total(
> | uvm_object | obj | = | null
> )

This is a pass through to uvm_objection::get_objection_total on the objection returned by get_objection.

> pure virtual function uvm_phase_hopper get_phase_hopper()

Returns the uvm_phase_hopper (singleton) instance for this environment

> static function bit get_print_config_matches()

static function bit get_print_config_matches()

> function process get_process()

Returns the currently guarded process, or null if the guard has been cleared.

> virtual function bit get_rand_mode()

Returns the rand_mode of the field instance

> virtual function int get_signal_size()

You must implement this function in the backdoor class to give you back the size of the signal @uvm-accellera The details of this API are specific to the Accellera implementation
This method tells you how many times the value of the signal changed.
Global object Macro definitions can be used in multiple locations

> virtual function void hdl_read(
> | ref | uvm_poll_status_e | status,
> | ref | uvm_poll_data_t | val
> )

This function will read the HDL value and return its value.

> function bit is_terminated()

Returns true if the guarded process terminated prior to being cleared; otherwise, returns false.

> static function bit is_tracing()

Returns 1 if the tracing facility is on and 0 if it is off.

> static function bit is_tracing()

Returns 1 if the tracing facility is on and 0 if it is off.

> pure virtual function optional_keys keys()

Returns a queue of all keys currently in the cache.

> virtual function optional_keys keys()

Returns a queue of all keys currently in the cache.

> rand uvm_access_e kind

Kind of access: READ or WRITE.
The library implements the following public API at the package level beyond what is documented in IEEE 1800.2.

> function new(
> | string | name | = | "unnamed-uvm_cache",
> | size_t | max_size | = | 256
> )

Constructor, initializes the cache.

> function new(
> | string | name | = | "uvm_hdl_polling"
> )

Constructor.

> function new(
> | string | name | = | ""
> )

Class Constructor

> function new(
> | string | name | = | "unnamed-uvm_lru_cache",
> | size_t | max_size | = | 256
> )

Constructor, initializes the cache.

> function new(
> | string | name | = | "uvm_phase_hopper"
> )

Creates a new uvm_phase_hopper instance with name.

> function new(
> | string | name | = | ""
> )

Class constructor

> function new(
> | string | name,
> | T | ctxt
> )

Constructor

> function new(
> | string | name
> )

Constructor.

> function new(
> | string | name | = | "unnamed-uvm_text_tr_database"
> )

Constructor

> function new(
> | string | name | = | "unnamed-uvm_text_tr_stream"
> )

Constructor

> rand uvm_reg_addr_t offset

For memory accesses, the offset address.
The cache can be queried for data at a given key.
The optional_keys type is similar to the optional_data type, however it stores keys instead of data.

> function void uvm_packer::pack_object_with_meta(
> | uvm_object | value
> )

Packs obj into the packer data stream, such that it can be unpacked via an associated unpack_object_with_meta call.
The packing macros are implemented as described in section B.2.4 of the 1800.2 specification.

> rand uvm_sequence_base parent

The sequence from which the operation originated.

> protected virtual task peek(
> | output | uvm_phase | phase
> )

Copies a phase from the hopper.

> virtual task poll_bkdr_wait_for_hdl_change(
> | ref | uvm_poll_status_e | status,
> | ref | uvm_poll_data_t | val
> )

This task is a hdl monitoring task that returns any time the monitored hdl signal changes its value.

> virtual task polling_wait_for_value(
> | ref | uvm_poll_status_e | status,
> | input | uvm_poll_data_t | exp_val
> )

Perform register/field polling.

> virtual function void print_accessors()

Delegates to the <uvm_resource_debug::print_access function to print the read/write access history of the resource, using the accessor argument accessor which is passed to the uvm_resource#(T)::read and uvm_resource#(T)::write

> virtual function void print_accessors()

Print the read/write access history of the resource, using the accessor argument accessor which is passed to the uvm_resource#(T)::read and uvm_resource#(T)::write

> static function void print_catcher(
> | UVM_FILE | file | = | 0
> )

Prints debug information about all of the typewide report catchers that are registered.

> function void print_config(
> | bit | recurse | = | 0,
> | bit | audit | = | 0
> )

Print_config prints all configuration information for this component, as set by previous calls to uvm_config_db::set() and exports to the resources pool.
The process guard classes, uvm_process_guard_base and uvm_process_guard#(T), are used to detect and potentially recover from unexpected termination of a SystemVerilog process.

> protected virtual task process_phase(
> | uvm_phase | phase
> )

Processes a phase.

> pure virtual function void put(
> | KEY_T | key,
> | DATA_T | data
> )

Puts data in cache at index key.

> virtual function void put(
> | KEY_T | key,
> | DATA_T | data
> )

Puts data in cache at index key.

> protected virtual function void raise_objection(
> | uvm_object | obj, |  |
> | string | description | = | "",
> | int | count | = | 1
> )

This is a pass through to uvm_objection::raise_objection on the objection returned by get_objection.

> virtual function bit read_by_name(
> |  | string | scope,
> |  | string | name,
> | inout | T | val,
> | input | uvm_object | accessor
> )

Provides an implementation of read_by_name, including support for resource tracing @uvm-accellera

> pure virtual function bit read_by_name(
> |  | string | scope,
> |  | string | name,
> | inout | T | val,
> | input | uvm_object | accessor
> )

Intended to provide the functionality for uvm_resource_db#(T)::read_by_name @uvm-contrib

> virtual function bit read_by_type(
> | input | string | scope,
> | inout | T | val,
> | input | uvm_object | accessor
> )

Provides an implementation of read_by_type, including support for resource tracing @uvm-accellera

> pure virtual function bit read_by_type(
> |  | string | scope,
> | inout | T | val,
> | input | uvm_object | accessor
> )

Intended to provide the functionality for uvm_resource_db#(T)::read_by_type @uvm-contrib

> bit record_all_messages = 0

A flag to force recording of all messages (add UVM_RM_RECORD action)

> function void record_read_access(
> | uvm_object | accessor | = | null
> )

Delegates to the <uvm_resource_debug::record_read_access function to record read access information for this resource for debug purposes, information used by print_accessors function.

> virtual function void record_read_access(
> | uvm_object | accessor | = | null
> )

Record the read access information for this resource for debug purposes.

> function void record_write_access(
> | uvm_object | accessor | = | null
> )

Delegates to the <uvm_resource_debug::record_write_access function to record write access information for this resource for debug purposes, information used by print_accessors function.

> virtual function void record_write_access(
> | uvm_object | accessor | = | null
> )

Record the write access information for this resource for debug purposes.
The recording macros are implemented as described in section B.2.3 of the 1800.2 specification.

> function bit register_hdl_path(
> | string | hdl_path_name
> )

This function registers a VPI value change callback for each RTL path Returns immediately if API callback was already registered Returns 1 if registration succeeded, 0 otherwise
Contains debug methods in the Accellera UVM implementation not documented in the IEEE 1800.2-2020 LRM

> virtual task run_phases()

Runs all phases associated with a test.

> protected virtual task schedule_phase(
> | uvm_phase | phase, |  |
> | uvm_phase | from_phase | = | null
> )

Performs actions associated with transitioning phase state to the UVM_PHASE_SCHEDULED state.

> virtual function void set(
> | string | cntxt_name,
> | string | inst_name,
> | string | field_name,
> | T | value,
> | int | cntxt_depth,
> | uvm_pool#(string, uvm_resource#(T)) | pool,
> | uvm_component | cntxt
> )

Provides an implementation of set, including support for config_db tracing @uvm-accellera

> pure virtual function void set(
> | string | cntxt_name,
> | string | inst_name,
> | string | field_name,
> | T | value,
> | int | cntxt_depth,
> | uvm_pool#(string, uvm_resource#(T)) | pool,
> | uvm_component | cntxt
> )

Intended to provide the functionality for uvm_config_db#(T)::set @uvm-contrib

> virtual function void set(
> | string | scope,
> | string | name,
> | T | val,
> | uvm_object | accessor
> )

Provides an implementation of set, including support for resource tracing @uvm-accellera

> pure virtual function void set(
> | string | scope,
> | string | name,
> | T | val,
> | uvm_object | accessor
> )

Intended to provide the functionality for uvm_resource_db#(T)::set @uvm-contrib

> virtual function void set_anonymous(
> | string | scope,
> | T | val,
> | uvm_object | accessor
> )

Provides an implementation of set_anonymous, including support for resource tracing @uvm-accellera

> pure virtual function void set_anonymous(
> | string | scope,
> | T | val,
> | uvm_object | accessor
> )

Intended to provide the functionality for uvm_resource_db#(T)::set_anonymous @uvm-contrib

> function void set_backdoor(
> | uvm_polling_backdoor | backdoor
> )

This method registers a backdoor class with the uvm_hdl_polling object.

> virtual function rsrc_t set_default(
> | string | scope,
> | string | name
> )

Provides an implementation of set_default.

> pure virtual function rsrc_t set_default(
> | string | scope,
> | string | name
> )

Intended to provide the functionality for uvm_resource_db#(T)::set_default @uvm-contrib

> function void set_enable_print_topology (
> | bit | enable
> )

Sets the variable to enable printing the entire testbench topology just after completion of the end_of_elaboration phase.

> function void set_file_name(
> | string | filename
> )

Sets the file name which will be used for output.
This method returns a summary statistic for the polling classes.
You may use this function to cache the full path to the signal.

> function void set_hdl_poll_cb_registered(
> | bit | value
> )

This method basically sets an internal variable if a callback has been registered to this polling object.

> static function void set_imp(
> | uvm_config_db_implementation_t | #(T) | imp | = | null
> )

1) the imp argument if it is not null, else 2) the relevant factory override of uvm_config_db_implementation_t#(T) if such an override exists, else 3) a new creation of uvm_config_db_default_implementation_t#(T) @uvm-contrib

> static function void set_imp(
> | uvm_resource_db_implementation_t | #(T) | imp | = | null
> )

1) the imp argument if it is not null, else 2) the relevant factory override of uvm_resource_db_implementation_t#(T) if such an override exists, else 3) a new creation of uvm_resource_db_default_implementation_t#(T) @uvm-contrib

> virtual function void set_max_size(
> | size_t | max_size | = | 256
> )

Sets the maximum size of the cache to max_size.

> static function void set_override(
> | input | string | scope, |  |
> | input | string | name, |  |
> |  | T | val, |  |
> |  | uvm_object | accessor | = | null
> )

Create a new resource, write val to it, and set it into the database.

> virtual function void set_override(
> | string | scope,
> | string | name,
> | T | val,
> | uvm_object | accessor
> )

Provides an implementation of set_override, including support for resource tracing @uvm-accellera

> pure virtual function void set_override(
> | string | scope,
> | string | name,
> | T | val,
> | uvm_object | accessor
> )

Intended to provide the functionality for uvm_resource_db#(T)::set_override @uvm-contrib

> static function void set_override_name(
> | input | string | scope, |  |
> | input | string | name, |  |
> |  | T | val, |  |
> |  | uvm_object | accessor | = | null
> )

Create a new resource, write val to it, and set it into the database.

> virtual function void set_override_name(
> | string | scope,
> | string | name,
> | T | val,
> | uvm_object | accessor
> )

Provides an implementation of set_override_name, including support for resource tracing @uvm-accellera

> pure virtual function void set_override_name(
> | string | scope,
> | string | name,
> | T | val,
> | uvm_object | accessor
> )

Intended to provide the functionality for uvm_resource_db#(T)::set_override_name @uvm-contrib

> static function void set_override_type(
> | input | string | scope, |  |
> | input | string | name, |  |
> |  | T | val, |  |
> |  | uvm_object | accessor | = | null
> )

Create a new resource, write val to it, and set it into the database.

> virtual function void set_override_type(
> | string | scope,
> | string | name,
> | T | val,
> | uvm_object | accessor
> )

Provides an implementation of set_override_type, including support for resource tracing @uvm-accellera

> pure virtual function void set_override_type(
> | string | scope,
> | string | name,
> | T | val,
> | uvm_object | accessor
> )

Intended to provide the functionality for uvm_resource_db#(T)::set_override_type @uvm-contrib

> function bit uvm_set_poll(
> | uvm_hdl_polling | poll_inst,
> | string | pathname
> )

simple set function that returns the poll instance for a given path @uvm-accellera The details of this API are specific to the Accellera implementation

> static function void set_print_config_matches(
> | bit | val
> )

static function void set_print_config_matches(bit val)

> virtual function void set_rand_mode(
> | bit | rand_mode
> )

Modifies the rand_mode for the field instance to the specified one

> static function bit set_type_alias(
> | string | alias_name
> )

Sets a type alias for this wrapper in the default factory.

> static function bit set_type_alias(
> | string | alias_name
> )

Sets a type alias for this wrapper in the default factory.

> static function bit set_type_alias(
> | string | alias_name
> )

Sets a type alias for this wrapper in the default factory.

> static function bit set_type_alias(
> | string | alias_name
> )

Sets a type alias for this wrapper in the default factory.

> virtual function void show_msg(
> | string | id,
> | string | rtype,
> | string | action,
> | string | scope,
> | string | name,
> | uvm_object | accessor,
> | rsrc_t | rsrc
> )

Provides an implementation of show_msg.

> pure virtual function void show_msg(
> | string | id,
> | string | rtype,
> | string | action,
> | string | scope,
> | string | name,
> | uvm_object | accessor,
> | rsrc_t | rsrc
> )

Intended to print a formatted string regarding an access of a particular config item @uvm-contrib

> virtual function void show_msg(
> | string | id,
> | string | rtype,
> | string | action,
> | string | scope,
> | string | name,
> | uvm_object | accessor,
> | rsrc_t | rsrc
> )

Provides an implementation of show_msg.

> pure virtual function void show_msg(
> | string | id,
> | string | rtype,
> | string | action,
> | string | scope,
> | string | name,
> | uvm_object | accessor,
> | rsrc_t | rsrc
> )

Intended to print a formatted string regarding an access of a particular resource @uvm-contrib

> bit show_terminator = 0

A flag to add a terminator in the messages, e.g.

> bit show_verbosity = 0

A flag to include verbosity in the messages, e.g.

> pure virtual function size_t size()

Returns the current number of elements in the cache.

> virtual function size_t size()

Returns the current number of elements in the cache.
An unsigned data type used for size operations on the cache.

> virtual task start(
> | uvm_sequencer_base | sequencer, |  |
> | uvm_sequence_base | parent_sequence | = | null,
> | int | this_priority | = | -1,
> | bit | call_pre_post | = | 1
> )

Starts the frontdoor sequence.

> protected virtual task start_phase(
> | uvm_phase | phase
> )

Performs actions associated with transitioning phase state to the UVM_PHASE_STARTED state.
Typedef representing this cache parameterization.
@uvm-contrib This API is being considered for potential contribution to 1800.2
Performs actions associated with transitioning phase state to the UVM_PHASE_SYNCING state.

> virtual function void traverse_on(
> | uvm_phase | imp,
> | uvm_component | comp,
> | uvm_phase | node,
> | uvm_phase_state | state
> )

Calls traverse on imp, passing in comp, node, and state.

> virtual function void trigger_modified(
> | string | inst_name,
> | string | field_name
> )

@uvm-accellera

> pure virtual function void trigger_modified(
> | string | inst_name,
> | string | field_name
> )

Triggers the event associated with inst_name and field_name, potentially unblocking calls to wait_modified.

> protected virtual function bit try_get(
> | inout | uvm_phase | phase
> )

Attempts to retrieve the next phase from the hopper.

> protected virtual function bit try_peek(
> | inout | uvm_phase | phase
> )

Attempts to copy a phase from the hopper.

> virtual function bit try_put(
> | uvm_phase | phase
> )

Attempts to add a new phase to the hopper.

> static function void turn_off_tracing()

Turn tracing off for the configuration database.

> static function void turn_off_tracing()

Turn tracing off for the resource database.

> static function void turn_on_tracing()

Turn tracing on for the configuration database.

> static function void turn_on_tracing()

Turn tracing on for the resource database.

> function void uvm_packer::unpack_object_with_meta(
> | inout | uvm_object | value
> )

Unpacks an object which was packed into the packer data stream using pack_object_with_meta.
Implementation of uvm_abstract_component_registry#(T,Tname), as defined by section 8.2.5.1.1 of 1800.2-2020.
Implementation of uvm_abstract_object_registry#(T,Tname), as defined by section 8.2.5.2.1 of 1800.2-2020.

> virtual class uvm_cache#(
> | type | KEY_T | = | int,
> | type | DATA_T | = | int
> ) extends uvm_object

Abstract base class for implementing a key/value pair cache.
The library implements the following public API beyond what is documented in 1800.2.
Implementation of uvm_component_registry#(T,Tname), as defined by section 8.2.3.1 of 1800.2-2020.
Provides an implementation of uvm_config_db_implementation_t#(T).
Abstract class representing the implementation details of the API for uvm_config_db#(T) to allow users to create alternate implementations

> class uvm_config_db_options

This class contains static functions for manipulating and retrieving options that control the behavior of the configuration DB facility.
Implementation of the uvm_copier class, as defined in section 16.6 of 1800.2-2020
Implementation of the uvm_core_state enumeration, as defined in section F.2.10 of 1800.2-2020.
The library implements the following public API in addition to what is documented in IEEE 1800.2.
Implementation of the uvm_default_coreservice_t as defined in section F.4.2.1 of 1800.2-2020.
Default implementation of the UVM factory.
Default implementation of the UVM report server, as defined in section 6.5.2 of 1800.2-2020
Performs the same function as the deprecated 1800.2 define UVM_DISABLE_RECORDING, globally turning off automatic item recording when defined by the user.
This is an implementation of uvm_event#(T) as described in 1800.2 with the addition of API described below.

> function uvm_hdl_polling uvm_get_poll(
> | string | pathname
> )

simple get function that returns the poll instance for a given path If no instance exists, it creates one and returns it.

> class uvm_hdl_polling extends uvm_object

Base class for HDL Polling functionality when using the uvm_hdl_polling class.

> virtual class uvm_hdl_polling_cbs extends uvm_callback

A base class for defining polling action callbacks to execute upon HDL path RTL signal value change
Implementation of uvm_init, as defined in section F.3.1.3 in 1800.2-2020.
The line printer prints output in a line format.
Implements a least recently used (LRU) cache.
Implementation of uvm_object_registry#(T,Tname), as defined by section 8.2.4.1 of 1800.2-2020.
Implementation of uvm_packer, as defined in section 16.5.1 of 1800.2-2020

> class uvm_phase_hopper extends uvm_object

The UVM phase hopper is responsible for the execution of the UVM phases during a test.
Backdoor base class for HDL Polling Extend this class and implement the methods in it to obtain backdoor functionality when using the uvm_hdl_polling class.
The library implements the following public API beyond what is documented in 1800.2.

> class uvm_port_component #(
> | type | PORT | = | uvm_object
> ) extends uvm_port_component_base

This implementation of uvm_port_component class from IEEE 1800.2 declares all the API described in the LRM, plus it inherits from uvm_port_component_base for the purpose of providing the get_connected_to() method.

> virtual class uvm_port_component_base extends uvm_component

This class defines an interface for obtaining a port’s connectivity lists after or during the end_of_elaboration phase.

> typedef uvm_port_component_base uvm_port_list[string]

Associative array of uvm_port_component_base class handles, indexed by string

> class uvm_process_guard#(
> | type | T | = | int
> ) extends uvm_process_guard_base

Ensures that processes are not killed in unexpected ways.

> virtual class uvm_process_guard_base extends uvm_object

Non-parameterized base class for uvm_process_guard#(T).
This is an implementation of uvm_reg as described in 1800.2 with the addition of API described below.

> class uvm_reg_err_service extends uvm_object

This class contains virtual functions implementing error messages from uvm_reg.
This is an implementation of uvm_reg_field as described in 1800.2 with the addition of API described below.
The library implements the following public API beyond what is documented in 1800.2.
Implementation of uvm_resource#(T) as defined in section C.2.5.1 of 1800.2-2020.
The library implements the following public API beyond what is documented in 1800.2.
Implementation of uvm_resource_db, as defined in section C.3.2.1 of 1800.2-2020, with the following additional API
Provides an implementation of uvm_resource_db_implementation_t#(T).
Abstract class representing the implementation details of the API for uvm_resource_db#(T) to allow users to create alternate implementations

> class uvm_resource_db_options

This class contains static functions for manipulating and retrieving options that control the behavior of the resources DB facility.

> class uvm_resource_debug extends uvm_object

Class provided to facilitate overriding of debug functions in the parameterized uvm_resource class.
The library implements the following public API beyond what is documented in 1800.2.

> class uvm_root extends uvm_component

Implementation of the uvm_root class, as defined in 1800.2-2020 Section F.7 with the following additional API
The library implements some public API beyond what is documented in 1800.2.
The table printer prints output in a tabular format.

> class uvm_text_recorder extends uvm_recorder

The uvm_text_recorder is the default recorder implementation for the uvm_text_tr_database.

> class uvm_text_tr_database extends uvm_tr_database

The uvm_text_tr_database is the default implementation for the uvm_tr_database.

> class uvm_text_tr_stream extends uvm_tr_stream

The uvm_text_tr_stream is the default stream implementation for the uvm_text_tr_database.
Implementation of uvm_tlm_generic_payload, as described in section 12.3.4.2.1 of 1800.2-2020.
By overriding various methods of the uvm_printer super class, the tree printer prints output in a tree format.

> task uvm_wait_for_nba_region

This task will block until SystemVerilog’s NBA region (or Re-NBA region if called from a program context).

> rand uvm_reg_data_t value[]

The value to write to, or after completion, the value read from the DUT.

> virtual task wait_for_hdl_change(
> | ref | uvm_poll_status_e | status,
> | ref | uvm_poll_data_t | val
> )

if you’re using the default VPI implementation Register a value change VPI callback if not already registered Wait for a value change and then Return the new value if you’re using the backdoor, it will return when the backdoor changes.

> virtual task wait_for_objection(
> | uvm_objection_event | objt_event, |  |
> | uvm_object | obj | = | null
> )

This is a pass through to uvm_objection::wait_for on the objection returned by get_objection.
Controls the number of wait_for_sequences calls when selecting next sequence.

> protected virtual task wait_for_waiters(
> | uvm_phase | phase,
> | uvm_phase_state | prev_state
> )

Delays execution to allow waiters on phase state changes to react.

> virtual task wait_modified(
> | uvm_component | cntxt,
> | string | inst_name,
> | string | field_name
> )

Provides an implementation of wait_modified @uvm-accellera

> pure virtual task wait_modified(
> | uvm_component | cntxt,
> | string | inst_name,
> | string | field_name
> )

Intended to provide the functionality for uvm_config_db#(T)::wait_modified @uvm-contrib

> function void write_attribute(
> | string | nm, |  |
> | uvm_bitstream_t | value, |  |
> | uvm_radix_enum | radix, |  |
> | int | numbits | = | $bits(uvm_bitstream_t)
> )

Outputs a uvm_bitstream_t attribute to the textual log.

> function void write_attribute_int(
> | string | nm, |  |
> | uvm_integral_t | value, |  |
> | uvm_radix_enum | radix, |  |
> | int | numbits | = | $bits(uvm_bitstream_t)
> )

Outputs an uvm_integral_t attribute to the textual log

> virtual function bit write_by_name(
> | string | scope,
> | string | name,
> | T | val,
> | uvm_object | accessor
> )

Provides an implementation of write_by_name, including support for resource tracing @uvm-accellera

> pure virtual function bit write_by_name(
> | string | scope,
> | string | name,
> | T | val,
> | uvm_object | accessor
> )

Intended to provide the functionality for uvm_resource_db#(T)::write_by_name @uvm-contrib

> virtual function bit write_by_type(
> | string | scope,
> | T | val,
> | uvm_object | accessor
> )

Provides an implementation of write_by_type, including support for resource tracing @uvm-accellera

> pure virtual function bit write_by_type(
> | string | scope,
> | T | val,
> | uvm_object | accessor
> )

Intended to provide the functionality for uvm_resource_db#(T)::write_by_type @uvm-contrib